%define ver 3_488

Summary: IOzone Filesystem Benchmark
Name: iozone
Version: 3.488
Release: 1
License: Freeware
Group: Applications/Engineering
URL: http://www.iozone.org
Source0: http://www.iozone.org/src/current/%{name}%{ver}.tar
Patch0: %{name}-%{version}-%{release}-aix.patch
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: AIX-rpm >= 5.3.0.0
BuildRequires: make, patch
Requires: AIX-rpm >= 5.3.0.0

%description
IOzone is a filesystem benchmark tool. The benchmark generates and 
measures a variety of file operations. IOzone has been ported to many machines and runs under many operating systems.

IOzone is useful for performing a broad filesystem analysis of a vendors
computer platform. The benchmark tests file I/O performance for the following
operations: Read, write, re-read, re-write, read backwards, read strided,
fread, fwrite, random read, pread ,mmap, aio_read, aio_write.


%prep
export PATH=/opt/freeware/bin:$PATH
%setup -n %{name}%{ver}
chmod -R u+w *
%patch0
chmod 0644 src/current/Gnuplot.txt


%build
cd src/current

gmake AIX CC=xlc_r
mv iozone iozone_AIX
mv fileop fileop_AIX
gmake clean

gmake AIX-LF CC=xlc_r
mv iozone iozone_AIX-LF
mv fileop fileop_AIX-LF
gmake clean

export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"

gmake AIX64 CC=xlc_r
mv iozone iozone_AIX64
mv fileop fileop_AIX64
gmake clean

gmake AIX64-LF CC=xlc_r
mv iozone iozone_AIX64-LF
mv fileop fileop_AIX64-LF
rm -f *.o


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
cd src/current

mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
cp iozone_AIX* fileop_AIX* pit_server ${RPM_BUILD_ROOT}%{_bindir}
chmod 0755 ${RPM_BUILD_ROOT}%{_bindir}/*
/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1
cp ${RPM_BUILD_DIR}/%{name}%{ver}/docs/iozone.1 ${RPM_BUILD_ROOT}%{_mandir}/man1
chmod 0644 ${RPM_BUILD_ROOT}%{_mandir}/man1/*

mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/%{name}
cp Generate_Graphs ${RPM_BUILD_ROOT}%{_datadir}/%{name}
cp gengnuplot.sh ${RPM_BUILD_ROOT}%{_datadir}/%{name}
cp gnu*.dem ${RPM_BUILD_ROOT}%{_datadir}/%{name}
chmod 0755 ${RPM_BUILD_ROOT}%{_datadir}/%{name}/Generate_Graphs
chmod 0755 ${RPM_BUILD_ROOT}%{_datadir}/%{name}/gengnuplot.sh
chmod 0644 ${RPM_BUILD_ROOT}%{_datadir}/%{name}/gnu*.dem

cd ${RPM_BUILD_ROOT}%{_bindir}
ln -s iozone_AIX64-LF iozone
ln -s fileop_AIX64-LF fileop

cd ${RPM_BUILD_ROOT}
mkdir -p usr/bin
cd usr/bin
ln -sf ../..%{_bindir}/* .


%post
echo ""
echo "Please note that POSIX aio may not be enabled by default on AIX."
echo "If you get messages like:"
echo ""
echo "    Symbol resolution failed for /usr/lib/libc.a(posix_aio.o) because:"
echo "        Symbol _posix_kaio_rdwr (number 2) is not exported from dependent
module /unix."
echo ""
echo "you need to enable POSIX aio. Run the following commands as root:"
echo ""
echo "    # lsdev -C -l posix_aio0"
echo "        posix_aio0 Defined  Posix Asynchronous I/O"
echo "    # cfgmgr -l posix_aio0"
echo "    # lsdev -C -l posix_aio0"
echo "        posix_aio0 Available  Posix Asynchronous I/O"
echo ""
echo "POSIX aio should work now. To make the change permanent (reboot required):
"
echo ""
echo "    # chdev -l posix_aio0 -P -a autoconfig='available'"
echo "        posix_aio0 changed"
echo ""


%files
%defattr(-,root,system,-)
%doc src/current/Gnuplot.txt
%doc docs/IOzone_msword_98.pdf
%doc docs/Iozone_ps.gz
%doc docs/Run_rules.doc
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/%{name}/*
/usr/bin/*


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%changelog
* Fri Aug 21 2020 Michael Perzl <michael@perzl.org> - 3_488-1
- updated to version 3_488-1

* Thu May 16 2019 Michael Perzl <michael@perzl.org> - 3_487-1
- updated to version 3_487-1

* Thu Mar 21 2019 Michael Perzl <michael@perzl.org> - 3_486-1
- updated to version 3_486-1

* Fri Dec 21 2018 Michael Perzl <michael@perzl.org> - 3_484-1
- updated to version 3_484-1

* Fri Dec 21 2018 Michael Perzl <michael@perzl.org> - 3_483-1
- updated to version 3_483-1

* Tue Jun 12 2018 Michael Perzl <michael@perzl.org> - 3_482-1
- updated to version 3_482-1

* Tue Jun 12 2018 Michael Perzl <michael@perzl.org> - 3_481-1
- updated to version 3_481-1

* Tue Jun 12 2018 Michael Perzl <michael@perzl.org> - 3_479-1
- updated to version 3_479-1

* Fri Apr 27 2018 Michael Perzl <michael@perzl.org> - 3_478-1
- updated to version 3_478-1

* Fri Apr 27 2018 Michael Perzl <michael@perzl.org> - 3_477-1
- updated to version 3_477-1

* Fri Apr 27 2018 Michael Perzl <michael@perzl.org> - 3_476-1
- updated to version 3_476-1

* Fri Apr 27 2018 Michael Perzl <michael@perzl.org> - 3_473-1
- updated to version 3_473-1

* Thu Oct 12 2017 Michael Perzl <michael@perzl.org> - 3_471-1
- updated to version 3_471-1

* Thu Oct 12 2017 Michael Perzl <michael@perzl.org> - 3_470-1
- updated to version 3_470-1

* Thu Oct 12 2017 Michael Perzl <michael@perzl.org> - 3_469-1
- updated to version 3_469-1

* Thu Oct 12 2017 Michael Perzl <michael@perzl.org> - 3_468-1
- updated to version 3_468-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_465-1
- updated to version 3_465-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_464-1
- updated to version 3_464-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_462-1
- updated to version 3_462-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_461-1
- updated to version 3_461-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_459-1
- updated to version 3_459-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_458-1
- updated to version 3_458-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_457-1
- updated to version 3_457-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_455-1
- updated to version 3_455-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_454-1
- updated to version 3_454-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_452-1
- updated to version 3_452-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_451-1
- updated to version 3_451-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_450-1
- updated to version 3_450-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_449-1
- updated to version 3_449-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_446-1
- updated to version 3_446-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_444-1
- updated to version 3_444-1

* Tue Jan 10 2017 Michael Perzl <michael@perzl.org> - 3_434-1
- updated to version 3_434-1

* Fri Jan 23 2015 Michael Perzl <michael@perzl.org> - 3_430-1
- updated to version 3_430-1

* Tue Aug 12 2014 Michael Perzl <michael@perzl.org> - 3_429-1
- updated to version 3_429-1

* Thu Jul 24 2014 Michael Perzl <michael@perzl.org> - 3_428-1
- updated to version 3_428-1

* Fri May 23 2014 Michael Perzl <michael@perzl.org> - 3_424-1
- updated to version 3_424-1

* Mon Sep 16 2013 Michael Perzl <michael@perzl.org> - 3_420-1
- updated to version 3_420-1

* Mon Sep 16 2013 Michael Perzl <michael@perzl.org> - 3_417-1
- updated to version 3_417-1

* Tue Oct 30 2012 Michael Perzl <michael@perzl.org> - 3_414-1
- updated to version 3_414-1

* Tue Jun 12 2012 Michael Perzl <michael@perzl.org> - 3_408-1
- updated to version 3_408-1

* Tue May 01 2012 Michael Perzl <michael@perzl.org> - 3_405-1
- updated to version 3_405-1

* Thu Apr 19 2012 Michael Perzl <michael@perzl.org> - 3_403-1
- updated to version 3_403-1

* Mon Feb 06 2012 Michael Perzl <michael@perzl.org> - 3_398-1
- updated to version 3_398-1

* Tue Nov 22 2011 Michael Perzl <michael@perzl.org> - 3_397-1
- updated to version 3_397-1

* Tue May 03 2011 Michael Perzl <michael@perzl.org> - 3_394-1
- updated to version 3_394-1

* Wed Oct 05 2010 Michael Perzl <michael@perzl.org> - 3_347-1
- updated to version 3_347-1
- fixed core dumps of 64-bit binaries

* Fri Jan 23 2009 Michael Perzl <michael@perzl.org> - 3_291-2
- fixed error for ASYNC IO for 32-bit binaries

* Tue Apr 08 2008 Michael Perzl <michael@perzl.org> - 3_291-1
- First version for AIX5L v5.1 and higher
